      // sito originario: Biblioteca www.steppa.net
     // (c) 2006 Emanuele Cassani
    // licenza: liberamente distribuibile se inalterato 
   // liberamente modificabile se mandate una copia all'autore
  // con autorizzazione all'eventuale pubblicazione e 
 // la spiegazione del vostro lavoro
// per dettagli vedere www.steppa.net/html/evoluzione/evoluzione.htm


tot=7;     // numero partecipanti
cicli=20; // numero mosse per partita

var nome = new Array(tot);
var DNA = new Array(tot);
var spiega = new Array(tot);
var colore = new Array(tot); // 1o
                            // A=verde (buono), T=rosso (cattivo)
                           // C=giallo (un po' buono), G=arancione (un po' cattivo)

var mutazione = new Array(tot); // 2o -> PER USO GENERAZIONI
                                 // diventa U se il DNA muta

var gioca1 = new Array(tot); // 3o prima giocata
// A=collabora, T=collabora C=defeziona G=casuale

var gioca2 = new Array(tot);   // 4o altre giocate (1o bit)
var gioca3 = new Array(tot);  // 5o altre giocate (2o bit)
var gioca4 = new Array(tot); // 6o altre giocate (3o bit)

var defeziona = new Array(tot); // 7o propensione alla cattiveria -> PER USO FUTURO
                               // quanto sei cattivo?

var vendicati = new Array(tot); // 8o propensione alla vendetta -> PER USO FUTURO
                               // quanto sei vendicativo?


 // ************************ DNA e strategie ****************************
// per spiegazioni sul funzionamento: www.steppa.net/html/evoluzione/evoluzione.htm

spiega[1]="strategia che collabora, a meno che l'altro non abbia defezionato";
nome[1] = "Tit for Tat";
DNA[1] = "AAATTTAG";

function tit_for_tat ()
{
// gene TTT

if (attenzione=="A"){
     if (giocoB1==0){giocoA=0}
     else {giocoA=1}
                 }
else {
     if (giocoA1==0){giocoB=0}
     else {giocoB=1}
     }
}

spiega[2]="strategia che collabora, a meno che l'altro non abbia defezionato 2 volte";
nome[2] = "Tit for two Tat";
DNA[2] = "AAATTGAG";

function tit_for_2tat ()
{
// gene TTG
if (attenzione=="A"){
     if (giocoB1==0 && giocoB2==0){giocoA=0}
     else {giocoA=1}
                 }
else {
     if (giocoA1==0 && giocoA2==0){giocoB=0}
     else {giocoB=1}
     }

}

spiega[3]="strategia che collabora, a meno che l'altro non abbia defezionato, ma ogni 5 volte defeziona";
nome[3] = "Tit for Tat - Trd";
DNA[3] = "GAATTAGT";


function tit_for_tat_TRD ()
{
// gene TTA

if (attenzione=="A"){
     if (giocoB1==0){giocoA=0}
     else {giocoA=1};
if (xx%5==0){giocoA=0}
                   }

else {
     if (giocoA1==0){giocoB=0}
     else {giocoB=1};
if (xx%5==0) {giocoB=0}
     }
}

spiega[4]="strategia che collabora, a meno che l'altro non abbia defezionato, ogni 5 volte defeziona, ma collabora se &egrave; stato lui a defezionare per primo";
nome[4] = "Tit for Tat - Rim";
DNA[4] = "GTATTCGT";

function tit_for_tat_RIM ()
{
// gene TTC

if (attenzione=="A"){
     if (giocoB1==0){giocoA=0}
     else {giocoA=1};
if (giocoA2==0){giocoA=1};
if (xx%5==0){giocoA=0}; // ogni 5 giocate
                   }

else {
     if (giocoA1==0){giocoB=0}
     else {giocoB=1};
if (giocoB2==0){giocoB=1};
if (xx%5==0) {giocoB=0}

     }

}

spiega[5]="strategia che collabora sempre"; 
nome[5] = "Sempre collabora";
DNA[5] = "AAAAAGGT";

function collabora_sempre ()
{
// gene AAG
if (attenzione=="A"){giocoA=1}
     else {giocoB=1};
}

spiega[6]="strategia che defeziona sempre";
nome[6] = "Sempre defeziona";
DNA[6] = "TACAAAGT";

function defeziona_sempre ()
{
// gene AAA
if (attenzione=="A"){giocoA=0}
     else {giocoB=0};
}


spiega[7]="strategia che gioca sempre in modo casuale";
nome[7] = "Completamete casuale";
DNA[7] = "GAGAACGT";

function casuale_sempre ()
{
// gene AAC
if (attenzione=="A"){giocoA=Math.floor(Math.random()*2)}
     else {giocoB=Math.floor(Math.random()*2)};
}
